import { Status } from "../../DataFrame";
import { IDevice } from "../Devices/IDevice";
import { ResponseResult } from "../FieldChangeResult";
import { ICustomUpdateActions } from "./CustomUpdateActions/ICustomUpdateActions";
import { IControllerUpdateInfo, IDeviceUpdateInfo } from "./IUpdateInfo";
import { IUpdatesService, UpdateAction, UpdateErrorCode, UpdateProgress } from "./IUpdatesService";
export declare class UpdatesService implements IUpdatesService {
    static readonly ServiceName: string;
    private _updateProviderService;
    constructor();
    GetServiceName(): string;
    CheckDeviceVersionAsync(deviceGuid: string): Promise<string | ResponseResult<UpdateErrorCode>>;
    CheckDeviceVersionAsync(device: IDevice): Promise<string | ResponseResult<UpdateErrorCode>>;
    CheckDeviceUpdateAsync(deviceGuid: string): Promise<IDeviceUpdateInfo | ResponseResult<UpdateErrorCode>>;
    CheckDeviceUpdateAsync(device: IDevice): Promise<IDeviceUpdateInfo | ResponseResult<UpdateErrorCode>>;
    InstallDeviceUpdateAsync<T extends ICustomUpdateActions>(device: IDevice, updateProgress: UpdateProgress, updateAction?: UpdateAction<T> | undefined): Promise<ResponseResult<UpdateErrorCode> | Status.OK>;
    InstallDeviceUpdateAsync<T extends ICustomUpdateActions>(dev: string, updateProgress: UpdateProgress, updateAction?: UpdateAction<T> | undefined): Promise<ResponseResult<UpdateErrorCode> | Status.OK>;
    CheckControllerUpdateAsync(): Promise<IControllerUpdateInfo>;
    CheckControllerVersionAsync(): Promise<string | ResponseResult<UpdateErrorCode>>;
    InstallControllerUpdatesAsync<T extends ICustomUpdateActions>(updateProgress: UpdateProgress, updateAction?: UpdateAction<T> | undefined): Promise<ResponseResult<UpdateErrorCode> | Status.OK>;
}
